local mod_gui = require '__core__/lualib/mod-gui'
local items = {"inserter", "transport-belt", "pipe", "pump"}
local on_player_created = function(event)
    local frame = mod_gui.get_frame_flow(game.get_player(event.player_index))

    local testFrame = frame.add{
        type = "frame",
        name = "testFrame",
        direction = "vertical"
    }

    local test1 = testFrame.add{
        type = "frame",
        caption = "Locked/Unlocked buttons",
        name = "test1",
        style = "bordered_frame"
    }

    for i = 1, 4 do
        local b = test1.add{
            type = "choose-elem-button",
            elem_type = "item",
            style = "logistic_button_slot"
        }
        b.elem_value = items[i]
        b.locked = b.elem_value
    end

    local test2 = testFrame.add{
        type = "frame",
        caption = "Unlocked buttons",
        name = "test2",
        style = "bordered_frame"
    }
    for i = 1, 4 do
        local b = test2.add{
            type = "choose-elem-button",
            elem_type = "item",
            elem_value = items[i],
            locked = true,
            style = "logistic_button_slot"
        }
        b.elem_value = items[i]
    end
    testFrame.add{
        type = "button",
        name = "reset",
        caption = "Reset"
    }
end
--logistic_button_selected_slot
script.on_event(defines.events.on_player_created, on_player_created)
script.on_event(defines.events.on_gui_click, function(event)
    local player = game.get_player(event.player_index)
    local testFrame = mod_gui.get_frame_flow(player).testFrame
    local element = event.element

    if element.name == "reset" then
        testFrame.destroy()
        global.selected = nil
        on_player_created(event)
        return
    end
    if not element.type == "choose-elem-button" and not element.elem_value then return end

    --Don't lock the buttons: works as expected, only that the item selection shows up everytime
    if element.parent.name == "test2" then

        if global.selected and global.selected.parent.name ~= element.parent.name then
            global.selected = nil
            player.print("Reset selection")
        end

        if not global.selected then--select button, lock it
            element.style = "logistic_button_selected_slot"
            global.selected = element
            log("Selected button: " .. tostring(element.elem_value))
        elseif global.selected and global.selected ~= element then--
            global.selected.style = "logistic_button_slot"
            log("Unselected button: " .. tostring(global.selected.elem_value))

            global.selected = element
            element.style = "logistic_button_selected_slot"
            log("Selected button: " .. tostring(element.elem_value))
        elseif global.selected and global.selected == element then --clicked the selected button the second time,
            global.selected.style = "logistic_button_slot"
            log("Updated style")
        end
        return
    end

    if not global.selected then--select button, lock it
        element.style = "logistic_button_selected_slot"
        element.locked = false
        global.selected = element
        log("Selected button: " .. tostring(element.elem_value))
    elseif global.selected and global.selected ~= element then--
        global.selected.style = "logistic_button_slot"
        global.selected.locked = true
        log("Unselected button: " .. tostring(global.selected.elem_value))

        global.selected = element
        element.style = "logistic_button_selected_slot"
        element.locked = false
        log("Selected button: " .. tostring(element.elem_value))
    elseif global.selected and global.selected == element then --clicked the selected button the second time,
        global.selected.style = "logistic_button_slot"
        log("Updated style")
    end
end)